function [ ] = drawAndPrintMatches(im1, im2, location1, location2, matches, filename, saveEmptyImage)
% output visualization for point correspondences.
% 
% input:  im1, im2 - two images on which we compared feautres
%         location1, location2 - [2xn] two sets of center points (x,y) for any
%                                features
%         matches - [2xn] conatains n columns of <i j> such that
%         location1(i) correspondce to location2(j)
% 
% output: a figure
%         

            %%%%DONE%%%%
warning('off', 'images:initSize:adjustingMag');
warning('off', 'MATLAB:prnRenderer:opengl');

dh1 = max(size(im2,1)-size(im1,1),0) ;
dh2 = max(size(im1,1)-size(im2,1),0) ;
img = [padarray(im1,dh1,'post') padarray(im2,dh2,'post')];

if (saveEmptyImage)
    imwrite(img, 'plainFig.png');
end
o = size(im1,2);

% Solution 1: use insertShape function. Problem: requires Computer Vision
% toolbox. 
lines = ([location1(1,matches(1,:));location1(2,matches(1,:));location2(1,matches(2,:))+o;location2(2,matches(2,:))]);
lines = lines';
co = get(gca,'ColorOrder');
colorsToUse = repmat(co,ceil(size(lines,1) / size(co,1)),1);
colorsToUse = colorsToUse(1:size(lines,1),:) * 255;
img = insertShape(img, 'Line', lines , 'LineWidth', 1, 'Color', colorsToUse);
imwrite(img, filename);

end