function [ samples, cornerMetric ] = adjustToBestCloseCorner( Ic, samples, searchExtent, searchMask)
%adjustToBestCloseCorner - Move samples to more "cornery" locations
if nargin > 3
    Ic(searchMask) = -inf;
end
samples = round(samples);
cornerMetric = zeros(size(samples,1),1);
[XX0,YY0] = meshgrid(-searchExtent(1):round(searchExtent(1)/4):searchExtent(1),-searchExtent(2):round(searchExtent(2)/4):searchExtent(2));
for sampleIdx = 1:size(samples,1)
    linIdxs = sub2ind(size(Ic),samples(sampleIdx,2) + YY0(:), samples(sampleIdx,1) + XX0(:));
    [cornerMetric(sampleIdx),maxIdx] = max(Ic(linIdxs));
    samples(sampleIdx,:) = samples(sampleIdx,:) + [XX0(maxIdx) YY0(maxIdx)];  
end

end

