function [ invHerrCovariance ] = getInvEstimationCovariance( srcPts, invCorrespondenceCovMat )
%getInvEstimationCovariance Calculate the inverse of the error covariance of the affine estimation
% Inputs:
% srcPts - N 2d points in the source image used for the estimation (NX2)
% invCorrespondenceCovMat - inverse of the correspondence error covariance reflecting the uncerteinty in the point matches (2N*2N matrix)
% Output:
% invHerrCovariance - The inverse of the error covariance of the affine estimation
X = zeros(2*size(srcPts,1),6);
X(1:2:end,1:3) = [srcPts ones(size(srcPts,1),1)];
X(2:2:end,4:6) = [srcPts ones(size(srcPts,1),1)];
invHerrCovariance = X'*invCorrespondenceCovMat*X;

end

