function [ points ] = sampleAround( centroid, radius, downSamplingFactor, minimalThetaRes)
% sampleAround - ger circular samples
% Inputs:
    % centroid - The center of the circle
    % radius - The radius of the circle
    % downSamplingFactor - how much to reduce relative to fully dense samples
    % minimalThetaRes - the minimal amount of samples on the circle
% Outputs:
    % points- the samples
numberOfPoints = max(round(2*pi*radius*downSamplingFactor),minimalThetaRes);
points = [linspace(0,(2*pi)*(1 - 1/numberOfPoints) ,numberOfPoints)' radius*ones(numberOfPoints,1)];
[points(:,1), points(:,2)] = pol2cart(points(:,1),points(:,2));
points(:,1) = points(:,1) + centroid(1);
points(:,2) = points(:,2) + centroid(2);
end

