function [bandIndicators, combinationFactors] = buildRotationCovariantBandIdxs(imageSize, numberOfBands)
% 

extent = floor(min(imageSize)/2);
[X, Y] = meshgrid(-extent:extent, -extent:extent);
[theta, r]=cart2pol(X, Y);
theta = theta + pi;
bandThetas = linspace(-eps, 2*pi, numberOfBands+1);
bandIndicators = false(imageSize(1), imageSize(2), numberOfBands);
for bandIdx = 1:numberOfBands
    bandIndicators(:, :, bandIdx) = r <= extent & (theta > bandThetas(bandIdx) & theta <= bandThetas(bandIdx+1));
end
combinationFactors = single([ones(2^(numberOfBands-1)-1, 1) (2*de2bi(0:(2^(numberOfBands-1) - 2)) - 1)]);
for combinationIdx = 1:size(combinationFactors, 1)
    positiveIndicators = (combinationFactors(combinationIdx,:) == 1);
    negativeIndicators = (combinationFactors(combinationIdx,:) == -1);
    combinationFactors(combinationIdx, negativeIndicators) = -1*sum(positiveIndicators)/sum(negativeIndicators);
end
end
