function [ bandIndicators, combinationFactors ] = buildRotationInvariantBandIdxs( imageSize, numberOfBands )
%UNTITLED7 Summary of this function goes here
%   Detailed explanation goes here
extent = floor(min(imageSize)/2);
bandRadis = [-1 sqrt(1:numberOfBands)*(extent/sqrt(numberOfBands))];
[X,Y]=meshgrid(-extent:extent,-extent:extent);
r = sqrt(X.^2 + Y.^2);
bandIndicators = false(imageSize(1),imageSize(2),numberOfBands);
for bandIdx = 1:numberOfBands
    bandIndicators(:,:,bandIdx) = r > bandRadis(bandIdx) & r <= bandRadis(bandIdx+1);
end
combinationFactors = single([ones(2^(numberOfBands-1)-1,1) (2*de2bi(0:(2^(numberOfBands-1) - 2)) - 1)]);
for combinationIdx = 1:size(combinationFactors,1)
    positiveIndicators = (combinationFactors(combinationIdx,:) == 1);
    negativeIndicators = (combinationFactors(combinationIdx,:) == -1);
    combinationFactors(combinationIdx,negativeIndicators) = -1*sum(positiveIndicators)/sum(negativeIndicators);
end
end

