function [H, descriptor] = getAffineInvDescAndCovFeatureUsingBinaryTemplates(I, Hn, invBandIndicators, invCombFactors, covBandIndicators, covCombFactors, xGrid, yGrid, mask, requiredSamples, thetaCords, rCords)

numberOfComplexInvariants = size(invCombFactors,1);
numberOfCovariants = size(covCombFactors,1);
descriptor = zeros(1+numberOfComplexInvariants+numberOfCovariants,1);
% [centroid,v1,v2,~,p] = getRegionPrincipleAxes(region);
% if(~p)
%     Hn = [v1(1) v2(1) centroid(1); v1(2) v2(2) centroid(2); 0 0 1];
% else
%     H = eye(3);
%     return;
% end
% widenRatio  = 1.2;
% NumOfSamples = min(51, widenRatio*2*norm(v1 + v2));
% NumOfSamples = 51;
% [xGrid,yGrid] = meshgrid(widenRatio*linspace(-1,1,NumOfSamples),widenRatio*linspace(-1,1,NumOfSamples));
[Xq,Yq] = affineTransformGrid(xGrid,yGrid,Hn);
minY = floor(min(Yq(:)));minX = floor(min(Xq(:)));maxX = ceil(max(Xq(:)));maxY = ceil(max(Yq(:)));
minY = max([minY 1]);minX = max([minX 1]);maxX = min([maxX size(I,2)]);maxY = min([maxY size(I,1)]);
affineNormalizedImage = interp2((minX:maxX),(minY:maxY),double(I(minY:maxY,minX:maxX)),Xq,Yq,'linear',0);
mu = mean(affineNormalizedImage(:));
sigma = sqrt(sum((affineNormalizedImage(:) - mu).^2));
affineNormalizedImage = (affineNormalizedImage - mu)/sigma; %normalize affine radiometric changes
% [R, theta, simpleInvariants] = rotationFromRthetaFuncs(affineNormalizedImage);
[ theta,simpleInvariants] = estimateRotationTrivialRadiEfficient(affineNormalizedImage,thetaCords,rCords,1);
R = [cos(theta) sin(theta) 0;-sin(theta) cos(theta) 0; 0 0 1];

R3 = eye(3);
R3(1:2,1:2) = R(1:2,1:2);
% rotatedImage = rotateImage(Inormalized,-theta);

values = giveRotatedSamples( requiredSamples, -theta, affineNormalizedImage );
rotatedImage = zeros(size(affineNormalizedImage));rotatedImage(mask) = values;

H = R3'/Hn;
invariantBandsSums = arrayfun(@(x) sum(sum(affineNormalizedImage(invBandIndicators(:,:,x)))) ,1:size(invBandIndicators,3));
covariantBandsSums = arrayfun(@(x) sum(sum(rotatedImage(covBandIndicators(:,:,x)))) ,1:size(covBandIndicators,3));
descriptor(1) = simpleInvariants(1);
descriptor(2:(2+numberOfComplexInvariants-1)) = invCombFactors*invariantBandsSums';
descriptor((2+numberOfComplexInvariants):length(descriptor))  = covCombFactors*covariantBandsSums';

end



